Index: CMT/v1r25-branch/ChangeLog
===================================================================
--- CMT/v1r25-branch/ChangeLog	(revision 646)
+++ CMT/v1r25-branch/ChangeLog	(revision 664)
@@ -1,2 +1,362 @@
+2014-01-10    <rybkin@lal.in2p3.fr> 522
+
+	* source/cmt_tag.cxx: Update authorship info
+	* source/cmt_std.h: idem
+	* source/cmt_awk.cxx: idem
+	* source/cmt_system.cxx: idem
+	* source/cmt_symbol.h: idem
+	* source/cmt_project.h: idem
+	* source/cmt_use.cxx: idem
+	* source/cmt_install_area.cxx: idem
+	* source/cmt_tag.h: idem
+	* source/cmt_deps_builder.cxx: idem
+	* source/cmt_fragment.cxx: idem
+	* source/cmt_generators.cxx: idem
+	* source/cmt_constituent.cxx: idem
+	* source/cmt.cxx: idem
+	* source/cmt_deps_builder.h: idem
+	* source/cmt_syntax.cxx: idem
+	* source/cmt_triggers.cxx: idem
+	* source/cmt_fragment.h: idem
+	* source/cmt_database.h: idem
+	* source/cmt_error.cxx: idem
+	* source/cmt_generators.h: idem
+	* source/cmt_model.cxx: idem
+	* source/cmt_commands.cxx: idem
+	* source/cmt_constituent.h: idem
+	* source/cmt_project.cxx: idem
+	* source/cmt_generator.h: idem
+	* source/cmt_pattern.cxx: idem
+	* source/cmt_error.h: idem
+	* source/cmt_regexp.h: idem
+	* source/cmt_parser.h: idem
+	* source/cmt_language.cxx: idem
+	* source/cmt_commands.h: idem
+	* source/cmt_lock.cxx: idem
+	* source/cmt_string.h: idem
+	* source/cmt_vcs.cxx: idem
+	* source/cmt_cmtpath_pattern.cxx: idem
+	* source/cmt_map.h: idem
+	* source/cmt_database.cxx: idem
+	* source/cmt_log.h: idem
+	* source/cmt_language.h: idem
+	* source/cmt_system.h: idem
+	* source/cmt_vcs.h: idem
+	* source/cmt_use.h: idem
+	* source/cmt_cmtpath_pattern.h: idem
+	* source/cmt_generator.cxx: idem
+	* source/cmt_regexp.cxx: idem
+	* source/cmt_cvs.cxx: idem
+	* source/cmt_parser.cxx: idem
+	* source/cmt_symbol.cxx: idem
+	* source/cmt.h: idem
+	* source/cmt_string.cxx: idem
+	* mgr/fragments/nmake/packages_header: idem
+	* mgr/fragments/packages_header: idem
+	* src/NMakefile.core: idem
+	* src/NMakefile.header: idem
+	* src/setup.tcsh: idem
+	* src/setup.zsh: idem
+	* src/Makefile.core: idem
+	* src/Makefile.header: idem
+
+2014-01-06    <rybkin@lal.in2p3.fr> 521
+
+	* source/cmt_tag.h: In class Tag, introduce static function apply_tag to
+	return map of tags and uses in which apply_tag statement appears for tag
+	* source/cmt_tag.cxx: In class Tag, in function action_apply update map of
+	tags and uses returned by function apply_tag, in function check_tag_used
+	return true if tag appears in apply_tag statement, in function
+	show_definition print uses in which apply_tag statement appears for tag
+	* source/cmt_map.h: In templated class cmt_vnode, remove const modifiers
+	for function find to allow for cmt_vnode value to be modified, in templated
+	class cmt_vmap, in function find remove const modifier for return value
+	to allow for cmt_vmap values to be modified
+	* source/cmt_parser.cxx: Implement helper function parse_cmt_flags to parse
+	-with(out)_cmt, -with(out)_projects, -(no)_strip_path flags from
+	requirements file, in class Cmt, modify function configure_current_package
+	to return location of requirements file if found, in function configure
+	make use of function parse_cmt_flags, do not read user requirements file(s)
+	for action_none
+	* source/cmt_symbol.cxx: In class PathBuilder, introduce static function
+	get_path_builder to return unique class instance, make assignment operator
+	and copy constructor private to forbid copying, make other constructors
+	private, in class Symbol functions create and set_strip_path make use of
+	function get_path_builder
+	* source/cmt.h: In class Cmt, modify function configure_current_package
+	signature
+	* mgr/requirements: Associate CMTv1 tag with with HEAD
+	
+2013-12-13    <rybkin@lal.in2p3.fr> 520
+
+	* mgr/CMT.dtd: Correct CMT site URL
+	
+2013-12-13    <rybkin@lal.in2p3.fr> 519
+
+	* source/cmt_symbol.cxx: In class Symbol function action, fully resolve
+	setup, cleanup script path except for setup, cleanup shell script
+	generation, in function print_clean, use unalias command to remove alias
+	with Bourne syntax shell, in function print, fully resolve set value, do
+	not mangle set, path name in Xml mode
+	* source/cmt_parser.cxx: In class Cmt function print_context, do not mangle
+	use prefix in Xml mode
+	
+2013-12-11    <rybkin@lal.in2p3.fr> 518
+
+	* source/cmt_commands.cxx: In class ArgParser, functions
+	option(_no)_path_strip renamed option(_no)_strip_path, command line options
+	-(no_)path_strip renamed -(no_)strip_path
+	* source/cmt_commands.h: idem
+	* source/cmt_symbol.h: In class class Symbol, function set_path_strip
+	renamed set_strip_path
+	* source/cmt_symbol.cxx: In class PathBuilder, functions get/set_path_strip
+	renamed get/set_strip_path, member m_path_strip renamed m_strip_path
+	* source/cmt.h: In class CmtContext, member m_path_strip renamed
+	m_strip_path, in class Cmt, function get_path_strip renamed get_strip_path
+	* source/cmt_parser.cxx: In class Cmt function do_setup, use
+	-no_strip_path,	-strip_path option names, function get_strip_path, class
+	Symbol function	set_strip_path
+	
+2013-12-06    <rybkin@lal.in2p3.fr> 517
+
+	* source/cmt_deps_builder.cxx: In helper function in_line_action, fix
+	parsing in case neither quotes or comments are found
+	
+2013-12-05    <rybkin@lal.in2p3.fr> 516
+
+	* source/cmt_deps_builder.cxx: In helper function at_start_action, fix
+	parsing Fortran INCLUDE statement, optimise in_line_action helper function,
+	in helper function build_deps_text, fix parsing C++ style comments in case
+	without other characters
+	* source/cmt_parser.cxx: In class Cmt function do_broadcast, add package,
+	version, offset info to printout of "cmt broadcast" command, similar to
+	printout in CMTBCAST mode
+	
+2013-12-03    <rybkin@lal.in2p3.fr> 515
+
+	* source/cmt_symbol.h: In class SymbolValueList function print, class
+	Symbol functions all_print, print introduce optional argument of type
+	ostream	reference, in class Symbol, declare static functions std_env_vars,
+	set_path_strip
+	* source/cmt_symbol.cxx: In class PathBuilder, introduce and implement
+	functions filter_path_value, get/set_path_strip, constructor with
+	path_strip argument and member m_path_strip to indicate whether to strip
+	paths of non-existent directories, in unnamed namespace, introduce cache
+	of command outputs for use in functions resolve_value,
+	resolve_value_for_macros, suppress_OS_delimiters, in class Symbol function
+	create, create PathBuilder instance with configured value of path_strip,
+	in class Symbol, implement static functions std_env_vars, set_path_strip,
+	control access to environment in functions resolve_value, class Symbol
+	functions all_set, get_env_value, class SetBuilder function build, class
+	PathBuilder function build, systematically use class PathBuilder function
+	filter_path_value in class Symbol functions all_set, check_all_paths,
+	print, in class PathBuilder function build, in class SymbolValueList
+	function print, modify helper function find_path_entry so as not to access
+	file system and return index of entry found, in class PathBuilder function
+	build, make use of signature to enhance implementation of path_append /
+	prepend commands, drop redundant cleaning of repeating path separators, in
+	class SymbolValueList function print, implement enhanced cached
+	requirements file generation, i.e., resolve sets for macros if possible,
+	resolve paths fully if possible, so as to strip path of non-existent
+	directories, implement use of argument of type ostream reference
+	* source/cmt_use.cxx: In class Use function fill_standard_macros, generate
+	CONFIG macros, if CONFIG environment variables are relevant, in setup
+	Requirements mode
+	* source/cmt_error.cxx: Cosmetic modifications to error messages
+	* source/cmt_commands.h: In class ArgParser, declare functions
+	option_with(out)_projects, option(_no)_path_strip
+	* source/cmt_commands.cxx: In class ArgParser, implement introduced
+	functions
+	* source/cmt.h: In class CmtContext, introduce member m_use_projects to
+	indicate whether to parse project files, member m_env_access to indicate
+	whether symbols values can be taken from environment, member m_print_mode
+	to hold	corresponding value from class ArgParser instance, member
+	m_path_strip to indicate whether to strip paths of non-existent
+	directories, in class Cmt functions print, print_context introduce optional
+	argument of type ostream reference, declare and implement inline functions
+	get/set_env_access, get/set_print_mode, get_path_strip
+	* source/cmt_parser.cxx: In class Cmt function configure_cmt_path, do not
+	create projects if m_use_projects is false, in function do_broadcast, set
+	cmtpath for all uses so as to fill in templates correctly, in function
+	do_check_configuration, do not run class Symbol function check_all_paths
+	for setup unless in Requirements mode (since paths checks are done in class
+	Symbol function print), in function do_setup, implement procedure of cached
+	requirements file generation, i.e., do not access environment to set
+	symbols values and, by default, strip paths of non-existent directories if
+	possible, in function guess_current_project, return if projects are not
+	used, do not change m_autoconfigure_cmtpath value, in functions print,
+	print_context, implement use of argument of type ostream reference, in
+	function print_context, in Requirements mode, generate CONFIG sets if
+	CONFIG environment variables are relevant, in function
+	use_special_requirements, handle case when projects are not used
+	* mgr/requirements: Associate CMTr25 tag with HEAD, append CMT to PATH as
+	in CMT setup scripts
+	
+2013-11-13    <rybkin@lal.in2p3.fr> 514
+
+	* source/cmt_use.cxx: In class Use get_strategy function, make use of now
+	fast get_project function rather than compute, in fill_standard_macros,
+	get_package_name, get_project functions, simplify code
+	* source/cmt_parser.cxx: In class Cmt install_scripts functions, make
+	generated setup and cleanup scrips call CMT executable directly rather than
+	via shell script wrapper
+	* src/setup.sh: Reduce usage of external shell utilities by using POSIX
+	shell features instead
+	* src/cleanup.sh: idem, unset everything set by setup.sh
+	* src/setup.csh: Reduce usage of external shell utilities by using C shell
+	features instead
+	* src/cleanup.csh: idem, unset everything set by setup.csh
+	* src/cleanup.tcsh: Add script to unset TCSH specific environment setup
+	* src/cleanup.zsh: Add script to unset Z shell specific environment setup
+	* src/cleanup.bash: Add script to unset BASH specific environment setup
+	
+2013-11-08    <rybkin@lal.in2p3.fr> 513
+
+	* source/cmt.h: In class CmtContext, make assignment operator and copy
+	constructor private to forbid copying, in class Cmt, inline simple member
+	functions for speed-up, add static member to hold reference to CmtContext
+	instance
+	* source/cmt_parser.cxx: Initialize static class Cmt member, comment out
+	inlined class Cmt methods implementation
+	
+2013-11-07    <rybkin@lal.in2p3.fr> 512
+
+	* source/cmt_tag.cxx: In class Tag mark function, do not activate tag if
+	in list of tags to remove, making -tag_remove=<tag-list> option functional
+	on any tags (rather than only those specified on the command line or in
+	CMTEXTRATAGS environment variable)
+	* source/cmt_syntax.cxx: In classes KwdBuildStrategy, KwdSetupStrategy,
+	KwdStructureStrategy action project function, make error description
+	detailed, in class SyntaxParser do_parse_words project function, print
+	error message in case of syntax error encountered in value
+	* source/cmt_parser.cxx: In class CmtContext, factor out processing of
+	CMTEXTRATAGS environment variable value into separate initialize function,
+	in class Cmt, move restore_all_tags call into configure function before all
+	system tags handling to make all initially known tags available while
+	reading project files, implement get_tags_remove function, in parser
+	function initialise static CmtContext instance at very beginning
+	* source/cmt.h: In class Cmt, declare get_tags_remove function
+	
+2013-11-05    <rybkin@lal.in2p3.fr> 511
+
+	* source/cmt_project.h: In class Project, change fill_selection function
+	signature to return projects (pointers), introduce function fill_exclusion
+	* source/cmt_project.cxx: In class ProjectFactory create_project function,
+	use change_path function on project use object, in class Project implement
+	fill_selection function for enhanced handling of special CMTHOME,
+	CMTUSERCONTEXT projects (selected if current project only) and special
+	depth values (0: CMTUSERCONTEXT project	only, -1: CMTHOME project only),
+	implement fill_exclusion function to exclude special CMTHOME,
+	CMTUSERCONTEXT projects unless current project, in find_in_cmt_paths
+	function fix search condition and comment out never used code, in
+	container_action function issue warning	or set error if container package
+	cannot be located
+	* source/cmt_use.h: In class Use, add member to hold project (pointer)
+	package	found in, add optional argument project (pointer) to change_path,
+	select_alternate functions, add	set_project function, inline located
+	function, make m_located member private
+	* source/cmt_use.cxx: In class Use, assign use project in function
+	change_path, in class UseProjectAction run and class Use select_alternate
+	functions, in particular, in functions get_cmtpath_and_offset,
+	fill_standard_macros, get_project make use of added class member (project)
+	for optimisation
+	* source/cmt_generators.h: In class PackagesMakefileGenerator, add member
+	m_ISINCLUDED
+	* source/cmt_generators.cxx: In class PackagesMakefileGenerator
+	constructor, reset function handle added member m_ISINCLUDED, in build
+	function make use of class Project fill_exclusion function and added
+	member to ensure packages from special CMTHOME, CMTUSERCONTEXT projects
+	are only visited, if in current project
+	* source/cmt_syntax.cxx: In class KwdBuildStrategy, KwdSetupStrategy,
+	KwdStructureStrategy action functions use class Use get_project function
+	for optimisation
+	* source/cmt_commands.cxx: In class ArgParser option_disable_warnings,
+	option_quiet, option_warnings functions, do not set CmtMessage level, add
+	option value to CMTFLAGS, in option_use, option_pack, option_version,
+	option_path functions only record option value, in option_tag,
+	option_tag_add, option_tag_remove functions, only record option values, in
+	option_with_version_directory, option_without_version_directory functions
+	do not change strategy, add option value to CMTFLAGS, in class CommandHelp
+	show_all function, add message for -home, -user_context options
+	* source/cmt_pattern.cxx: In class Pattern expand function, use class Use
+	get_project function for optimisation
+	* source/cmt_parser.cxx: In class CmtContext constructor, process
+	CMTEXTRATAGS environment variable value, in clear function, reset all
+	members, in class Cmt configure function, attempt to locate current use
+	or package if at least name is available from command line options before
+	configure_current_package for optimisation, in configure_current_cmtpath
+	function make use of class Use get_cmtpath_and_offset function,
+	return from configure_current_package if current use is located, in
+	configure_current_structuring_style function, do not parse command line
+	arguments, make use of value from command line or parse CMTFLAGS to set
+	strategy accordingly, in configure_home, configure_user_context functions,
+	use value from command line if any, in restore_all_tags function, add tags
+	from CmtContext m_extra_tags, m_tags, m_tags_add vectors, in
+	configure_cmt_message function do not parse command line arguments, parse
+	CMTFLAGS, in do_broadcast function, set error if depth option value cannot
+	be parsed or is out of range (< -1), make use of class Project
+	fill_selection, fill_exclusion functions to implement enhanced handling of
+	special CMTHOME, CMTUSERCONTEXT projects packages (visited if in current
+	project only) and and special depth values (0: CMTUSERCONTEXT project
+	packages only, -1: CMTHOME project packages only), in
+	do_check_configuration function, check tags from CmtContext m_extra_tags,
+	m_tags, m_tags_add vectors, in do_show_clients function do not re-run
+	configure, in guess_current_project function, do not use CmtSystem cd or
+	pwd functions for optimisation, in parse_arguments function do not call
+	restore_all_tags function, in parser function call parse_arguments first
+	and then configure, restore_all_tags to make configuration process cleaner,
+	do not call configure for action_build_temporary_name, in print function do
+	not check tags or change m_extra_tags since that change affects nothing, in
+	use_current_package, use_extra_file functions do not attempt to locate
+	current package if current use located already, factor out
+	Pattern::apply_all_globalsize and Tag::restore_tree calls into separate
+	apply_globals function called after all requirements are read, in
+	use_special_requirements function set special use style, structuring_style,
+	project members if located, otherwise discard, in particular, that means
+	that requirements file in special CMTHOME, CMTUSERCONTEXT projects is not
+	mandatory
+	* source/cmt_symbol.cxx: In class Symbol action function, make
+	constituentsclean symbol private (like constituents)
+	* source/cmt.h: In class CmtContext, add string vector members
+	m_extra_tags, m_tags, m_tags_add, m_tags_remove instead of string
+	m_extra_tags, in class Cmt, function reach_current_package renamed
+	use_current_package, introduce apply_globals function
+	* mgr/fragments/nmake/package: Ensure that not included packages are
+	not visited
+	* mgr/fragments/package: idem
+	* src/Makefile.header: Update help messages for BCAST mode in presence of
+	special CMTHOME, CMTUSERCONTEXT packages/projects
+
+2013-10-04    <rybkin@lal.in2p3.fr> 510
+
+	* mgr/cmt-make-time-sub-mem-io.awk: Add script to profile CMT commands
+	utilisation in the Makefiles
+
+2013-07-31    <rybkin@lal.in2p3.fr> 509
+
+	* mgr/cmt_svn_checkout.py: Add support for devbranches directory -
+	additional branches location - in Subversion repository.
+
+2013-07-10    <rybkin@lal.in2p3.fr> 508
+
+	* source/cmt_commands.cxx: In class ArgParser function option_use, make
+	-use=<package>:<version>:<path> option fully functional with standard use
+	statement syntax, in function option_path, make -path=<path> option
+	functional for relative <path> as with standard use statement syntax
+	* source/cmt_parser.cxx: In class Cmt functions reach_current_package,
+	use_extra_file make diagnostic message more informative
+
+2013-07-09    <rybkin@lal.in2p3.fr> 507
+
+	* mgr/cmt_svn_checkout.py: Use a different algorithm in the class Checkout
+	function trunk_tag in order to optimise the performance, suggested by
+	Wim Lavrijsen. Add --debug command line option and SVNDEBUG environment
+	variable to facilitate debugging
+
+2013-06-25    <rybkin@lal.in2p3.fr> 506
+
+	* mgr/fragments/application: Test use_stamps variable for a non-empty value
+	since POSIX requires a non-null list of targets in rules
+
 2013-06-24    <rybkin@lal.in2p3.fr> 505
 
Index: CMT/v1r25-branch/mgr/CMT.dtd
===================================================================
--- CMT/v1r25-branch/mgr/CMT.dtd	(revision 646)
+++ CMT/v1r25-branch/mgr/CMT.dtd	(revision 664)
@@ -1,3 +1,3 @@
-<!ENTITY  % cmtns   "xmlns CDATA #FIXED 'http://www.cmtsite.org/cmt'">
+<!ENTITY  % cmtns   "xmlns CDATA #FIXED 'http://www.cmtsite.net/cmt'">
 <!ATTLIST setup     %cmtns;>
 <!ATTLIST projects  %cmtns;>
Index: CMT/v1r25-branch/mgr/cmt-make-time-sub-mem-io.awk
===================================================================
--- CMT/v1r25-branch/mgr/cmt-make-time-sub-mem-io.awk	(revision 664)
+++ CMT/v1r25-branch/mgr/cmt-make-time-sub-mem-io.awk	(revision 664)
@@ -0,0 +1,105 @@
+#! /usr/bin/awk -f
+#
+# Profile CMT commands utilisation in the Makefiles
+#
+# Usage:
+#
+# export VERBOSE=1
+# export TIME="%U user %S system %e elapsed %P CPU %C (%Xtext+%Ddata %Mmax)k %Iinputs+%Ooutputs (%Fmajor+%Rminor)pagefaults %Wswaps %cswitch %wswitch voluntarily"
+# 
+# \time cmt br make -j1 cmtexe="'\time ${CMTROOT}/${CMTBIN}/cmt.exe'" >&cmt-br-make-time.log&
+# OR
+# \time cmt br make -j1 cmtexe="'\time ${CMTROOT}/${CMTBIN}/cmt.exe'" cpp="'\time c++'" cc="'\time cc'" make_shlib="'\time ${CMTROOT}/mgr/cmt_make_shlib_common.sh extract'" >&cmt-br-make-time.log&
+#
+# ./cmt-make-time-sub-mem-io.awk cmt-br-make-time.log
+#
+$2 == "user" && $4 == "system" && $6 == "elapsed" {
+#if ($9 == "g++") {
+  if ($9 ~ /([gc]\+\+|g?cc)$/) {
+    gxx_u += $1; gxx_s += $3; gxx_e += $5; gxx_i += 1
+    if ($0 ~ /-MM/) {
+      dep_u += $1; dep_s += $3; dep_e += $5; dep_i += 1
+    }
+  }
+  else if ($9 ~ /cmt_make_shlib_common\.sh$/) {
+    make_shlib_u += $1; make_shlib_s += $3; make_shlib_e += $5; make_shlib_i += 1
+  }
+  else if ($9 ~ /\/CMT\/(v[[:digit:]]+(r[[:digit:]]+)?(p[[:digit:]]+)?)|HEAD\//) {
+    cmt_tot_u += $1; cmt_tot_s += $3; cmt_tot_e += $5; cmt_tot_i += 1
+    if ($0 ~ /-f=.+/) fast=1
+    else fast=0
+    for (i=10; i<=NF; i++) {
+      if ($i ~ /-.+/) continue
+      k=$i" "$(i+1)
+      if (fast == 1) {
+	cmt_f_u[k] += $1; cmt_f_s[k] += $3; cmt_f_e[k] += $5; cmt_f_i[k] += 1
+      }
+      else {
+	cmt_u[k] += $1; cmt_s[k] += $3; cmt_e[k] += $5; cmt_i[k] += 1
+      }
+      break
+    }
+# Maximum resident set size of the process during its lifetime, in Kilobytes
+    _rss_max = $(NF - 6)
+    sub("max)k", "", _rss_max)
+    rss_max += _rss_max
+    rss_max_i += 1
+
+    _major = gensub(/\(([[:digit:]]+)major\+([[:digit:]]+)minor\)pagefaults/, "\\1", "1", $(NF - 4))
+    _minor = gensub(/\(([[:digit:]]+)major\+([[:digit:]]+)minor\)pagefaults/, "\\2", "1", $(NF - 4))
+    major_pf += _major
+    minor_pf += _minor
+
+    cswitch += gensub(/([[:digit:]]+)switch/, "\\1", "1", $(NF - 2))
+    wswitch += gensub(/([[:digit:]]+)switch/, "\\1", "1", $(NF - 1))
+  }
+#  else
+#    print "Ignoring command: "$9
+}
+function prec (val)
+{
+  if (val >= 100) return 0
+  else if (val >= 10) return 1
+  else return 2
+}
+END {
+  printf "\nFile(s):"
+  for (i = 1; i < ARGC; i++) {
+    if (ARGV[i] ~ /^(_|[[:alpha:]])_*[[:alpha:]]*[[:digit:]]*=/) continue
+    printf " %s", ARGV[i]
+  }
+  printf "\n"
+
+  if (make_shlib_i != 0)
+    printf "cmt_make_shlib_common.sh[%d]: %.*f user %.*f system %.*f elapsed\n"	\
+      , make_shlib_i, prec(make_shlib_u), make_shlib_u, prec(make_shlib_s), make_shlib_s, prec(make_shlib_e), make_shlib_e
+  if (gxx_i != 0)
+    printf "c++/cc[%d]: %.*f user %.*f system %.*f elapsed\n"	\
+      , gxx_i, prec(gxx_u), gxx_u, prec(gxx_s), gxx_s, prec(gxx_e), gxx_e
+  if (dep_i != 0)
+    printf "dep[%d]: %.*f user %.*f system %.*f elapsed\n"	\
+      , dep_i, prec(dep_u), dep_u, prec(dep_s), dep_s, prec(dep_e), dep_e
+  printf "cmt[%d]: %.*f user %.*f system %.*f elapsed\n"	\
+    , cmt_tot_i, prec(cmt_tot_u), cmt_tot_u, prec(cmt_tot_s), cmt_tot_s, prec(cmt_tot_e), cmt_tot_e
+  printf "average rss_max: %.0fk\npage faults: %d major + %d minor\ncontext switch: %d involuntarily + %d voluntarily\n" \
+    , (rss_max_i != 0 ? rss_max/rss_max_i : 0), major_pf, minor_pf, cswitch, wswitch
+  print "Breakdown:"
+  for (n in cmt_f_i) {
+    printf "cmt fast [%s] [%d]: %.*f user %.*f system %.*f elapsed\n"	\
+      , n, cmt_f_i[n], prec(cmt_f_u[n]), cmt_f_u[n], prec(cmt_f_s[n]), cmt_f_s[n], prec(cmt_f_e[n]), cmt_f_e[n]
+    f_i += cmt_f_i[n]; f_u += cmt_f_u[n]; f_s += cmt_f_s[n]; f_e += cmt_f_e[n]
+  }
+  printf "cmt fast [%d]: %.*f user %.*f system %.*f elapsed\n"	\
+    , f_i, prec(f_u), f_u, prec(f_s), f_s, prec(f_e), f_e
+  i=0
+  for (n in cmt_i) {
+    printf "cmt [%s] [%d]: %.*f user %.*f system %.*f elapsed\n"	\
+      , n, cmt_i[n], prec(cmt_u[n]), cmt_u[n], prec(cmt_s[n]), cmt_s[n], prec(cmt_e[n]), cmt_e[n]
+    i += cmt_i[n]; u += cmt_u[n]; s += cmt_s[n]; e += cmt_e[n]
+  }
+  printf "cmt [%d]: %.*f user %.*f system %.*f elapsed\n"	\
+    , i, prec(u), u, prec(s), s, prec(e), e
+
+  if ($0 != "")
+    printf "\n%s\n", $0
+}
